// WL_ACT1.C

#include "wl_def.h"
#pragma hdrstop

/*
=============================================================================

                                                        STATICS

=============================================================================
*/


statobj_t       statobjlist[MAXSTATS];
statobj_t       *laststatobj;


struct
{
    short      picnum;
    wl_stat_t  type;
    uint32_t   specialFlags;    // they are ORed to the statobj_t flags
} statinfo[] =
{
    {SPR_STAT_0,bo_gibs},                   // Puddle          spr1v
    {SPR_STAT_1,block},                     // Table w/ food   "
    {SPR_STAT_2,block},                     // Table           "
    {SPR_STAT_3,block,FL_FULLBRIGHT},       // Floor lamp      "
    {SPR_STAT_4,none,FL_FULLBRIGHT},        // Ceiling light   "
    {SPR_STAT_5,none,FL_FULLBRIGHT},        // Ceiling light   "
    {SPR_STAT_6,bo_alpo},                   // Cold food       "
    {SPR_STAT_7,block},                     // Tech column     "
    //
    // NEW PAGE
    //
    {SPR_STAT_8,block},                     // Potted plant    spr2v
    {SPR_STAT_9,bo_25clip},                 // Ammo box        "
    {SPR_STAT_10},                          // Corpse          "
    {SPR_STAT_11,block},                    // Toilet /w lid o "
    {SPR_STAT_12,block},                    // Toilet /w lid c "
    {SPR_STAT_13,block},                    // Sink            "
    {SPR_STAT_14,block},                    // Chair           "
    #ifndef SPEAR
    {SPR_STAT_15},                          // Kitchen stuff   "
    #else
    {SPR_STAT_15,block},                    // Executive chair "
    #endif
    //
    // NEW PAGE
    //
    {SPR_STAT_16,block},                    // Armchair        spr3v
    {SPR_STAT_17,block},                    // Couch           "
    {SPR_STAT_18,bo_key1},                  // Blue key        "
    {SPR_STAT_19,bo_key2},                  // Yellow key      "
    {SPR_STAT_20,bo_key3},                  // Red key         "
    {SPR_STAT_21,bo_key4},                  // Green key       "
    {SPR_STAT_22,block},                    // Flag            "
    {SPR_STAT_23,block},                    // Desk 1          "
    //
    // NEW PAGE
    //
    {SPR_STAT_24,bo_food},                  // First aid       spr4v
    {SPR_STAT_25,bo_medkit},                // First aid       "
    {SPR_STAT_26,bo_clip},                  // Clip            "
    {SPR_STAT_27,bo_machinegun},            // Shotgun         "
    {SPR_STAT_28,bo_chaingun},              // MGX 2704        "
    {SPR_STAT_29,bo_cross},                 // Money bag       "
    {SPR_STAT_30,bo_chalice},               // Coin            "
    {SPR_STAT_31,bo_bible},                 // 5 coins         "
    //
    // NEW PAGE
    //
    {SPR_STAT_32,bo_fullheal},              // Backpack        spr5v
    {SPR_STAT_33,block},                    // Bed             "
    {SPR_STAT_34,block},                    // Chamber         "
    {SPR_STAT_35,none,FL_FULLBRIGHT},       // Exit sign       "
    {SPR_STAT_36,block},                    // Trash bin       "
    {SPR_STAT_37,block},                    // Wastepaper bin  "
    {SPR_STAT_38,bo_implant},               // Implant         "
    {SPR_STAT_39,block},                    // Computer        "
    //
    // NEW PAGE
    //
    #ifndef SPEAR
    {SPR_STAT_40,block},                    // Call Apogee     spr7v
    #else
    {SPR_STAT_40,none,FL_FULLBRIGHT},       // Red light       spr7v
    #endif
    //
    // NEW PAGE
    //
    {SPR_STAT_41,none,FL_FULLBRIGHT},       // Red light       "
    {SPR_STAT_42},                          // Security camera "
    {SPR_STAT_43,bo_clip2},                 // Shotgun shells  "
    #ifndef SPEAR
    {SPR_STAT_44},                          // Pots            "
    #else
    {SPR_STAT_44},                          // Pots            "
    #endif
    {SPR_STAT_45,block},                    // Operating table "
    {SPR_STAT_46,block},                    // Operating table "
    {SPR_STAT_47,block},                    // Operating table "
    //
    // NEW PAGE
    //
    #ifdef SPEAR
    {SPR_STAT_59,block},                    // Stove           spr8v
    {SPR_STAT_60},                          // Bottle 1        "
    {SPR_STAT_61},                          // Bottle 2        "
    {SPR_STAT_62},                          // Bottle 3        "
    {SPR_STAT_63},                          // Shower head     "
    {SPR_STAT_64},                          // Log disc 1      "
    {SPR_STAT_65,bo_godmode},               // Syringe         "
    {SPR_STAT_66},                          // Boxes           "
    //
    // NEW PAGE
    //
	{SPR_STAT_67},                          // Trash           spr9v
#ifdef USE_DIR3DSPR
	{SPR_STAT_68,block,FL_DIR_HORIZ_MID},    // Glass 1         "
    {SPR_STAT_68,block,FL_DIR_VERT_MID},     // Glass 2         "
	{SPR_STAT_69,block,FL_DIR_HORIZ_MID},    // Stone wall 1    "
    {SPR_STAT_70,block,FL_DIR_VERT_MID},     // Stone wall 2    "
	{SPR_STAT_71,block,FL_DIR_HORIZ_MID},    // Fence 1         "
    {SPR_STAT_71,block,FL_DIR_VERT_MID},     // Fence 2         "
#endif
	{SPR_STAT_72,block},                    // File cabinet    "
    //
    // NEW PAGE
    //
	{SPR_STAT_73,block},                    // Barrel          spr10v
	{SPR_STAT_74,block},                    // Car             "
	{SPR_STAT_75,block},                    // Desk 2          "
	{SPR_STAT_76,block},                    // Kitchen sink    "
	{SPR_STAT_77},                          // Log disc 2      "
	{SPR_STAT_78},                          // Log disc 3      "
	{SPR_STAT_79},                          // Log disc 4      "
	{SPR_STAT_80},                          // Dead cook       "
    //
    // NEW PAGE
    //
	{SPR_STAT_81,block},                    // Gun locker 1    spr11v
	{SPR_STAT_82,block},                    // Gun locker 2    "
	{SPR_STAT_83,block},                    // Gun locker 3    "
	{SPR_STAT_84,block},                    // Gun locker 4    "
	{SPR_STAT_85,block},                    // Gun locker 5    "
	{SPR_STAT_86,bo_diary1},                // Diary 1         "
	{SPR_STAT_87,bo_diary2},                // Diary 2         "
	{SPR_STAT_88,bo_diary3},                // Diary 3         "
    //
    // NEW PAGE
    //
	{SPR_STAT_89,bo_arm},                   // Disembodied arm spr12v
	{SPR_STAT_95,bo_children},              // Ugly children   "
	{SPR_SPECTRE_W1,bo_hostage},            // Hostage         "
	{SPR_SPECTRE_W2,bo_hostage},            // Hostage         "
	{SPR_SPECTRE_W3,bo_hostage},            // Hostage         "
	{SPR_SPECTRE_W4,bo_hostage},            // Hostage         "
	{SPR_SPECTRE_F1,bo_hostage},            // Hostage         "
	{SPR_SPECTRE_F2,bo_hostage},            // Hostage         "
    //
    // NEW PAGE
    //
	{SPR_SPECTRE_F3,bo_hostage},            // Hostage         spr13v
	{SPR_SPECTRE_F4,bo_hostage},            // Hostage         "
	{SPR_STAT_96,block},                    // Nuke barrel     "
	{SPR_STAT_97,bo_nuke},                  // Nuke puddle     "
	{SPR_STAT_98,block},                    // Tool cabinet    "
	{SPR_STAT_99,block},                    // Tyre and axes   "
	{SPR_STAT_100,block},                   // Pumping station "
    #endif

    {-1}                                    // Terminator
};

/*
===============
=
= InitStaticList
=
===============
*/

void InitStaticList (void)
{
    laststatobj = &statobjlist[0];
}



/*
===============
=
= SpawnStatic
=
===============
*/

void SpawnStatic (int tilex, int tiley, int type)
{
    laststatobj->shapenum = statinfo[type].picnum;
    laststatobj->tilex = tilex;
    laststatobj->tiley = tiley;
    laststatobj->visspot = &spotvis[tilex][tiley];

    switch (statinfo[type].type)
    {
        case block:
            actorat[tilex][tiley] = (objtype *) 64;          // consider it a blocking tile
        case none:
            laststatobj->flags = 0;
            break;

		case	bo_children:
		case	bo_cross:
		case	bo_chalice:
		case	bo_bible:
		case	bo_fullheal:
		case	bo_hostage:
            if (!loadedgame)
                gamestate.treasuretotal++;

		case	bo_medkit:
		case	bo_key1:
		case	bo_key2:
		case	bo_key3:
		case	bo_key4:
		case	bo_clip:
		case	bo_clip2:
		case	bo_25clip:
		case	bo_machinegun:
		case	bo_chaingun:
		case	bo_food:
		case	bo_alpo:
		case	bo_godmode:
		case	bo_implant:
		case	bo_diary1:
		case	bo_diary2:
		case	bo_diary3:
		case	bo_arm:
		case	bo_nuke:
		case	bo_gibs:
            laststatobj->flags = FL_BONUS;
            laststatobj->itemnumber = statinfo[type].type;
            break;
    }

    laststatobj->flags |= statinfo[type].specialFlags;

    laststatobj++;

    if (laststatobj == &statobjlist[MAXSTATS])
        Quit ("Too many static objects!\n");
}


/*
===============
=
= PlaceItemType
=
= Called during game play to drop actors' items.  It finds the proper
= item number based on the item type (bo_???).  If there are no free item
= spots, nothing is done.
=
===============
*/

void PlaceItemType (int itemtype, int tilex, int tiley)
{
    int type;
    statobj_t *spot;

    //
    // find the item number
    //
    for (type=0; ; type++)
    {
        if (statinfo[type].picnum == -1)                    // end of list
            Quit ("PlaceItemType: couldn't find type!");
        if (statinfo[type].type == itemtype)
            break;
    }

    //
    // find a spot in statobjlist to put it in
    //
    for (spot=&statobjlist[0]; ; spot++)
    {
        if (spot==laststatobj)
        {
            if (spot == &statobjlist[MAXSTATS])
                return;                                     // no free spots
            laststatobj++;                                  // space at end
            break;
        }

        if (spot->shapenum == -1)                           // -1 is a free spot
            break;
    }
    //
    // place it
    //
    spot->shapenum = statinfo[type].picnum;
    spot->tilex = tilex;
    spot->tiley = tiley;
    spot->visspot = &spotvis[tilex][tiley];
    spot->flags = FL_BONUS | statinfo[type].specialFlags;
    spot->itemnumber = statinfo[type].type;
}



/*
=============================================================================

                                  DOORS

doorobjlist[] holds most of the information for the doors

doorposition[] holds the amount the door is open, ranging from 0 to 0xffff
        this is directly accessed by AsmRefresh during rendering

The number of doors is limited to 64 because a spot in tilemap holds the
        door number in the low 6 bits, with the high bit meaning a door center
        and bit 6 meaning a door side tile

Open doors conect two areas, so sounds will travel between them and sight
        will be checked when the player is in a connected area.

Areaconnect is incremented/decremented by each door. If >0 they connect

Every time a door opens or closes the areabyplayer matrix gets recalculated.
        An area is true if it connects with the player's current spor.

=============================================================================
*/

#define DOORWIDTH       0x7800
#define OPENTICS        300

doorobj_t       doorobjlist[MAXDOORS],*lastdoorobj;
short           doornum;

word            doorposition[MAXDOORS];             // leading edge of door 0=closed
                                                    // 0xffff = fully open

byte            areaconnect[NUMAREAS][NUMAREAS];

boolean         areabyplayer[NUMAREAS];


/*
==============
=
= ConnectAreas
=
= Scans outward from playerarea, marking all connected areas
=
==============
*/

void RecursiveConnect (int areanumber)
{
    int i;

    for (i=0;i<NUMAREAS;i++)
    {
        if (areaconnect[areanumber][i] && !areabyplayer[i])
        {
            areabyplayer[i] = true;
            RecursiveConnect (i);
        }
    }
}


void ConnectAreas (void)
{
    memset (areabyplayer,0,sizeof(areabyplayer));
    areabyplayer[player->areanumber] = true;
    RecursiveConnect (player->areanumber);
}


void InitAreas (void)
{
    memset (areabyplayer,0,sizeof(areabyplayer));
    if (player->areanumber < NUMAREAS)
        areabyplayer[player->areanumber] = true;
}



/*
===============
=
= InitDoorList
=
===============
*/

void InitDoorList (void)
{
    memset (areabyplayer,0,sizeof(areabyplayer));
    memset (areaconnect,0,sizeof(areaconnect));

    lastdoorobj = &doorobjlist[0];
    doornum = 0;
}


/*
===============
=
= SpawnDoor
=
===============
*/

void SpawnDoor (int tilex, int tiley, boolean vertical, int lock)
{
    word *map;

    if (doornum==MAXDOORS)
        Quit ("64+ doors on level!");

    doorposition[doornum] = 0;              // doors start out fully closed
    lastdoorobj->tilex = tilex;
    lastdoorobj->tiley = tiley;
    lastdoorobj->vertical = vertical;
    lastdoorobj->lock = lock;
    lastdoorobj->action = dr_closed;

    actorat[tilex][tiley] = (objtype *)(uintptr_t)(doornum | 0x80);   // consider it a solid wall

    //
    // make the door tile a special tile, and mark the adjacent tiles
    // for door sides
    //
    tilemap[tilex][tiley] = doornum | 0x80;
    map = mapsegs[0] + (tiley<<mapshift) +tilex;
    if (vertical)
    {
        *map = *(map-1);                        // set area number
        tilemap[tilex][tiley-1] |= 0x40;
        tilemap[tilex][tiley+1] |= 0x40;
    }
    else
    {
        *map = *(map-mapwidth);                                 // set area number
        tilemap[tilex-1][tiley] |= 0x40;
        tilemap[tilex+1][tiley] |= 0x40;
    }

    doornum++;
    lastdoorobj++;
}

//===========================================================================

/*
=====================
=
= OpenDoor
=
=====================
*/

void OpenDoor (int door)
{
    if (doorobjlist[door].action == dr_open)
        doorobjlist[door].ticcount = 0;         // reset open time
    else
        doorobjlist[door].action = dr_opening;  // start it opening
}


/*
=====================
=
= CloseDoor
=
=====================
*/

void CloseDoor (int door)
{
    int     tilex,tiley,area;
    objtype *check;

    //
    // don't close on anything solid
    //
    tilex = doorobjlist[door].tilex;
    tiley = doorobjlist[door].tiley;

    if (actorat[tilex][tiley])
        return;

    if (player->tilex == tilex && player->tiley == tiley)
        return;

    if (doorobjlist[door].vertical)
    {
        if ( player->tiley == tiley )
        {
            if ( ((player->x+MINDIST) >>TILESHIFT) == tilex )
                return;
            if ( ((player->x-MINDIST) >>TILESHIFT) == tilex )
                return;
        }
        check = actorat[tilex-1][tiley];
        if (ISPOINTER(check) && ((check->x+MINDIST) >> TILESHIFT) == tilex )
            return;
        check = actorat[tilex+1][tiley];
        if (ISPOINTER(check) && ((check->x-MINDIST) >> TILESHIFT) == tilex )
            return;
    }
    else if (!doorobjlist[door].vertical)
    {
        if (player->tilex == tilex)
        {
            if ( ((player->y+MINDIST) >>TILESHIFT) == tiley )
                return;
            if ( ((player->y-MINDIST) >>TILESHIFT) == tiley )
                return;
        }
        check = actorat[tilex][tiley-1];
        if (ISPOINTER(check) && ((check->y+MINDIST) >> TILESHIFT) == tiley )
            return;
        check = actorat[tilex][tiley+1];
        if (ISPOINTER(check) && ((check->y-MINDIST) >> TILESHIFT) == tiley )
            return;
    }


    //
    // play door sound if in a connected area
    //
    area = *(mapsegs[0] + (doorobjlist[door].tiley<<mapshift)
        +doorobjlist[door].tilex)-AREATILE;
    if (areabyplayer[area])
    {
        PlaySoundLocTile(CLOSEDOORSND,doorobjlist[door].tilex,doorobjlist[door].tiley); // JAB
    }

    doorobjlist[door].action = dr_closing;
    //
    // make the door space solid
    //
    actorat[tilex][tiley] = (objtype *)(uintptr_t)(door | 0x80);
}



/*
=====================
=
= OperateDoor
=
= The player wants to change the door's direction
=
=====================
*/

void OperateDoor (int door)
{
    int lock;

    lock = doorobjlist[door].lock;
    if (lock >= dr_lock1 && lock <= dr_lock4)
    {
        if ( ! (gamestate.keys & (1 << (lock-dr_lock1) ) ) )
        {
            SD_PlaySound (TAKEDAMAGESND);                // locked
            return;
        }
    }

    switch (doorobjlist[door].action)
    {
        case dr_closed:
        case dr_closing:
            OpenDoor (door);
            break;
        case dr_open:
        case dr_opening:
            CloseDoor (door);
            break;
    }
}


//===========================================================================

/*
===============
=
= DoorOpen
=
= Close the door after three seconds
=
===============
*/

void DoorOpen (int door)
{
    if ( (doorobjlist[door].ticcount += (short) tics) >= OPENTICS)
        CloseDoor (door);
}



/*
===============
=
= DoorOpening
=
===============
*/

void DoorOpening (int door)
{
    unsigned area1,area2;
    word *map;
    int32_t position;

    position = doorposition[door];
    if (!position)
    {
        //
        // door is just starting to open, so connect the areas
        //
        map = mapsegs[0] + (doorobjlist[door].tiley<<mapshift)
            +doorobjlist[door].tilex;

        if (doorobjlist[door].vertical)
        {
            area1 = *(map+1);
            area2 = *(map-1);
        }
        else
        {
            area1 = *(map-mapwidth);
            area2 = *(map+mapwidth);
        }
        area1 -= AREATILE;
        area2 -= AREATILE;

        if (area1 < NUMAREAS && area2 < NUMAREAS)
        {
            areaconnect[area1][area2]++;
            areaconnect[area2][area1]++;

            if (player->areanumber < NUMAREAS)
                ConnectAreas ();

            if (areabyplayer[area1])
                PlaySoundLocTile(OPENDOORSND,doorobjlist[door].tilex,doorobjlist[door].tiley);  // JAB
        }
    }

    //
    // slide the door by an adaptive amount
    //
    position += tics<<10;
    if (position >= 0xffff)
    {
        //
        // door is all the way open
        //
        position = 0xffff;
        doorobjlist[door].ticcount = 0;
        doorobjlist[door].action = dr_open;
        actorat[doorobjlist[door].tilex][doorobjlist[door].tiley] = 0;
    }

    doorposition[door] = (word) position;
}


/*
===============
=
= DoorClosing
=
===============
*/

void DoorClosing (int door)
{
    unsigned area1,area2;
    word *map;
    int32_t position;
    int tilex,tiley;

    tilex = doorobjlist[door].tilex;
    tiley = doorobjlist[door].tiley;

    if ( ((int)(uintptr_t)actorat[tilex][tiley] != (door | 0x80))
        || (player->tilex == tilex && player->tiley == tiley) )
    {                       // something got inside the door
        OpenDoor (door);
        return;
    };

    position = doorposition[door];

    //
    // slide the door by an adaptive amount
    //
    position -= tics<<10;
    if (position <= 0)
    {
        //
        // door is closed all the way, so disconnect the areas
        //
        position = 0;

        doorobjlist[door].action = dr_closed;

        map = mapsegs[0] + (doorobjlist[door].tiley<<mapshift) + doorobjlist[door].tilex;

        if (doorobjlist[door].vertical)
        {
            area1 = *(map+1);
            area2 = *(map-1);
        }
        else
        {
            area1 = *(map-mapwidth);
            area2 = *(map+mapwidth);
        }
        area1 -= AREATILE;
        area2 -= AREATILE;

        if (area1 < NUMAREAS && area2 < NUMAREAS)
        {
            areaconnect[area1][area2]--;
            areaconnect[area2][area1]--;

            if (player->areanumber < NUMAREAS)
                ConnectAreas ();
        }
    }

    doorposition[door] = (word) position;
}




/*
=====================
=
= MoveDoors
=
= Called from PlayLoop
=
=====================
*/

void MoveDoors (void)
{
    int door;

    if (gamestate.victoryflag)              // don't move door during victory sequence
        return;

    for (door = 0; door < doornum; door++)
    {
        switch (doorobjlist[door].action)
        {
            case dr_open:
                DoorOpen (door);
                break;

            case dr_opening:
                DoorOpening(door);
                break;

            case dr_closing:
                DoorClosing(door);
                break;
        }
    }
}


/*
=============================================================================

                                PUSHABLE WALLS

=============================================================================
*/

word pwallstate;
word pwallpos;                  // amount a pushable wall has been moved (0-63)
word pwallx,pwally;
byte pwalldir,pwalltile;
int dirs[4][2]={{0,-1},{1,0},{0,1},{-1,0}};

/*
===============
=
= PushWall
=
===============
*/

void PushWall (int checkx, int checky, int dir)
{
    int oldtile, dx, dy;

    if (pwallstate)
        return;

    oldtile = tilemap[checkx][checky];
    if (!oldtile)
        return;

    dx = dirs[dir][0];
    dy = dirs[dir][1];

    if (actorat[checkx+dx][checky+dy])
    {
        SD_PlaySound (NOWAYSND);
        return;
    }
    actorat[checkx+dx][checky+dy] = (objtype *)(uintptr_t) (tilemap[checkx+dx][checky+dy] = oldtile);

    gamestate.secretcount++;
    pwallx = checkx;
    pwally = checky;
    pwalldir = dir;
    pwallstate = 1;
    pwallpos = 0;
    pwalltile = tilemap[pwallx][pwally];
    tilemap[pwallx][pwally] = 64;
    tilemap[pwallx+dx][pwally+dy] = 64;
    *(mapsegs[1]+(pwally<<mapshift)+pwallx) = 0;   // remove P tile info
    *(mapsegs[0]+(pwally<<mapshift)+pwallx) = *(mapsegs[0]+(player->tiley<<mapshift)+player->tilex); // set correct floorcode (BrotherTank's fix)

    SD_PlaySound (PUSHWALLSND);
	GetMessage("You found a secret area!");
}



/*
=================
=
= MovePWalls
=
=================
*/

void MovePWalls (void)
{
    int oldblock,oldtile;

    if (!pwallstate)
        return;

    oldblock = pwallstate/128;

    pwallstate += (word)tics;

    if (pwallstate/128 != oldblock)
    {
        // block crossed into a new block
        oldtile = pwalltile;

        //
        // the tile can now be walked into
        //
        tilemap[pwallx][pwally] = 0;
        actorat[pwallx][pwally] = 0;
        *(mapsegs[0]+(pwally<<mapshift)+pwallx) = player->areanumber+AREATILE;

        int dx=dirs[pwalldir][0], dy=dirs[pwalldir][1];
        //
        // see if it should be pushed farther
        //
		// changed by havoc
        if (pwallstate>=384)            // only move three tiles fix
        {
            //
            // the block has been pushed two tiles
            //
            pwallstate = 0;
            tilemap[pwallx+dx][pwally+dy] = oldtile;
            return;
        }
        else
        {
            int xl,yl,xh,yh;
            xl = (player->x-PLAYERSIZE) >> TILESHIFT;
            yl = (player->y-PLAYERSIZE) >> TILESHIFT;
            xh = (player->x+PLAYERSIZE) >> TILESHIFT;
            yh = (player->y+PLAYERSIZE) >> TILESHIFT;

            pwallx += dx;
            pwally += dy;

            if (actorat[pwallx+dx][pwally+dy]
                || xl<=pwallx+dx && pwallx+dx<=xh && yl<=pwally+dy && pwally+dy<=yh)
            {
                pwallstate = 0;
                tilemap[pwallx][pwally] = oldtile;
                return;
            }
            actorat[pwallx+dx][pwally+dy] = (objtype *)(uintptr_t) (tilemap[pwallx+dx][pwally+dy] = oldtile);
            tilemap[pwallx+dx][pwally+dy] = 64;
        }
    }

    pwallpos = (pwallstate/2)&63;
}
